(* Title:  "Minisubpbl/200-start-method-NEXT_STEP.sml"
   Author: Walther Neuper 1105
   (c) copyright due to lincense terms.
*)

open Rewrite;
open Pos;
open TermC;

"----------- Minisubplb/250-Rewrite_Set-from_method-NEXT_STEP.sml ----------------------------";
"----------- Minisubplb/250-Rewrite_Set-from_method-NEXT_STEP.sml ----------------------------";
"----------- Minisubplb/250-Rewrite_Set-from_method-NEXT_STEP.sml ----------------------------";
"----------- Minisubplb/250-Rewrite_Set-from_method-NEXT_STEP.sml ----------------------------";
val fmz = ["equality (x+1=(2::real))", "solveFor x", "solutions L"];
val (dI',pI',mI') =
  ("Test", ["sqroot-test", "univariate", "equation", "test"],
   ["Test", "squ-equ-test-subpbl1"]);
val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
(*[], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []);(*Model_Problem*)
(*[], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []);(*Specify_Theory "Test"*)
(*[], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []);(*Specify_Problem ["sqroot-test", "univariate", "equation", "test"*)
(*[], Met*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []);(*Specify_Method ["Test", "squ-equ-test-subpbl1"]*)
(*[1], Frm*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []);(*Apply_Method ["Test", "squ-equ-test-subpbl1"]*)
(*[1], Res*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []);(*Rewrite_Set "norm_equation"*)
(*[2], Res*)val (_, ([(tac''''', _, _)], _, (pt''''', p'''''))) = Step.do_next p ((pt, e_pos'), []);(*Rewrite_Set "Test_simplify"*)

(*//------------------ step into Rewrite_Set "norm_equation" -------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis))
  = (p''', ((pt''', e_pos'), []));
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

      Step.switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos))
  = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*else*);

        LI.do_next (pt, input_pos);
"~~~~~ and do_next , args:"; val (ptp as (pt, pos as (p, p_))) = (pt, input_pos);
    (*if*) MethodC.id_empty = get_obj g_metID pt (par_pblobj pt p) (*else*);
	      val ((ist, ctxt), sc) = LItool.resume_prog (p,p_) pt;

        (*case*)
        LI.find_next_step sc (pt, pos) ist ctxt (*of*);
"~~~~~ fun find_next_step , args:"; val ((Rule.Prog prog), (ptp as (pt, pos as (p, _))), (Istate.Pstate ist), ctxt)
  = (sc, (pt, pos), ist, ctxt);

    (*case*)
        LI.scan_to_tactic (prog, (ptp, ctxt)) (Istate.Pstate ist) (*of*);
"~~~~~ fun scan_to_tactic , args:"; val ((prog, cc), (Istate.Pstate (ist as {path, ...})))
  = ((prog, (ptp, ctxt)), (Istate.Pstate ist) );
  (*if*) path = [] (*else*);

        LI.go_scan_up (prog, cc) (Istate.trans_scan_up ist);
"~~~~~ fun go_scan_up , args:"; val ((pcc as (sc, _)), (ist as {path, act_arg, found_accept, ...}))
  = ((prog, cc), (Istate.trans_scan_up ist));
    (*if*) path = [R] (*root of the program body*) (*else*);

        LI.scan_up pcc (ist |> Istate.path_up) (go_up path sc);
"~~~~~ fun scan_up , args:"; val (pcc, ist, (Const (\<^const_name>\<open>Tactical.Try\<close>(*2*), _) $ _))
  = (pcc, (ist |> Istate.path_up), (go_up path sc));

        LI.go_scan_up pcc ist;
"~~~~~ fun go_scan_up , args:"; val ((pcc as (sc, _)), (ist as {path, act_arg, found_accept, ...}))
  = (pcc, ist);
    (*if*) path = [R] (*root of the program body*) (*else*);

        LI.scan_up pcc (ist |> Istate.path_up) (go_up path sc);
"~~~~~ fun scan_up , args:"; val (pcc as (sc, cc as (_, ctxt)), ist, (Const (\<^const_name>\<open>Tactical.Chain\<close>(*3*), _) $ _))
  = (pcc, (ist |> Istate.path_up), (go_up path sc));
        val e2 = LI.check_Seq_up ctxt ist sc;

        (*case*)
        LI.scan_dn cc (ist |> Istate.path_up_down [R]) e2 (*of*);
"~~~~~ fun scan_dn , args:"; val (cc, (ist as {act_arg, ...}), (Const (\<^const_name>\<open>Tactical.Try\<close>(*2*), _) $ e))
  = (cc, (ist |> Istate.path_up_down [R]), e2 );

    (*case*)
        LI.scan_dn cc (ist |> Istate.path_down [R]) e (*of*);
"~~~~~ fun scan_dn , args:"; val ((cc as (_, ctxt)), (ist as {eval, ...}), t (*fall-through*))
  = (cc, (ist |> Istate.path_down [R]), e);
    (*if*) Tactical.contained_in t (*else*);
val (Program.Tac prog_tac, form_arg) =
      (*case*) LItool.check_leaf "next  " ctxt eval (Istate.get_subst ist) t (*of*);

        LI.check_tac cc ist (prog_tac, form_arg);
"~~~~~ fun check_tac , args:"; val (((pt, p), ctxt), ist, (prog_tac, form_arg))
  = (cc, ist, (prog_tac, form_arg));
    val m = LItool.tac_from_prog (pt, p) prog_tac
val _ =
    (*case*) m (*of*);

      (*case*)
Solve_Step.check m (pt, p) (*of*);
"~~~~~ fun check , args:"; val ((Tactic.Rewrite_Set rls), (cs as (pt, pos)) )
  = (m, (pt, p));
        val ctxt = Ctree.get_loc pt pos |> snd
        val thy' = ctxt |> Proof_Context.theory_of |> Context.theory_name
        val f = Calc.current_formula cs;

(*+*)val ctxt = Config.put rewrite_trace true ctxt;
val SOME (f', asm) = (*case*)
   Rewrite.rewrite_set_ ctxt false (get_rls ctxt rls) f (*of*);
(*+*)val ctxt = Config.put rewrite_trace false ctxt;
(*
@# rls: Test_simplify on: x + 1 + - 1 * 2 = 0 
@## try thm: "real_diff_minus" 
@## try thm: "radd_mult_distrib2" 
@## try thm: "rdistr_right_assoc" 
@## try thm: "rdistr_right_assoc_p" 
@## try thm: "rdistr_div_right" 
@## try thm: "rbinom_power_2" 
@## try thm: "radd_commute" 
@### eval asms: "x + 1 + - 1 * 2 = - 1 * 2 + (x + 1)" 
@## not >: "x + 1 + - 1 * 2" > "- 1 * 2 + (x + 1)" 
@### eval asms: "x + 1 = 1 + x" 
@## rewrites to: "1 + x + - 1 * 2 = 0" 
@## try thm: "radd_commute" 
@### eval asms: "1 + x + - 1 * 2 = - 1 * 2 + (1 + x)" 
@## not >: "1 + x + - 1 * 2" > "- 1 * 2 + (1 + x)" 
@### eval asms: "1 + x = x + 1" 
@## not >: "1 + x" > "x + 1" 
@## try thm: "radd_left_commute" 
@## try thm: "add.assoc" 
@### eval asms: "1 + x + - 1 * 2 = 1 + (x + - 1 * 2)" 
@## rewrites to: "1 + (x + - 1 * 2) = 0" 
@## try thm: "add.assoc" 
@## try thm: "rmult_commute" 
@### eval asms: "- 1 * 2 = 2 * - 1" 
@## not >: "- 1 * 2" > "2 * - 1" 
@## try thm: "rmult_left_commute" 
@## try thm: "rmult_assoc" 
@## try thm: "radd_real_const_eq" 
@## try thm: "radd_real_const" 
@## try calc: "Groups.plus_class.plus" 
@## try calc: "Groups.times_class.times" 
-------------------------------------------- ME_Isa: thy "Isac_Knowledge" not in system
@### eval asms: "- 1 * 2 = - 2" 
@## calc. to: 1 + (x + - 2) = 0 
@## try calc: "Groups.times_class.times" 
@## try calc: "Rings.divide_class.divide" 
@## try calc: "BaseDefinitions.realpow" 
:
*)
(*-------------------- stop step into Rewrite_Set --------------------------------------------*)
(*\\------------------ step into Rewrite_Set -----------------------------------------------//*)

(* final test ... ----------------------------------------------------------------------------*)
(*+*)val ([2], Res) = p''''';
Test_Tool.show_pt_tac pt'''''; (*[
([], Frm), solve (x + 1 = 2, x)
. . . . . . . . . . Apply_Method ["Test", "squ-equ-test-subpbl1"], 
([1], Frm), x + 1 = 2
. . . . . . . . . . Rewrite_Set "norm_equation", 
([1], Res), x + 1 + - 1 * 2 = 0
. . . . . . . . . . Rewrite_Set "Test_simplify", 
([2], Res), - 1 + x = 0
. . . . . . . . . . Check_Postcond ["sqroot-test", "univariate", "equation", "test"]]   ..INCORRECT
*)
